#!/usr/bin/env python
# -*- coding: utf-8 -*-
import telnetlib # http://python.fyxm.net/doc/2.2.3/lib/telnet-objects.html
import re,os
"""

| add XYZ  . . . . . . .  ajoute XYZ à la playlist
| playlist . . affiche les éléments de la playlist
| play . . . . . . . . . . . . . . .  joue le flux
| stop . . . . . . . . . . . . . .  arrête le flux
| next . . . . . . . . item de la playlist suivant
| prev . . . . . . . item de la playlist précédent
| goto . . . . . . . . aller à l’élément
| title [X]  .  modifie/affiche le titre de l’item
| title_n  . . . titre suivant dans l’item courant
| title_p  . . titre précédent dans l’item courant
| chapter [X]  . . . . modifie/affiche le chapitre
| chapter_n   chapitre suivant dans l’item courant
| chapter_p  . . .  chapitre précédant dans l’item
| seek X .  déplacement en secondes, ex. « seek 12 »
| pause  . . . . . . . . . . . . . . bascule pause
| fastforward . . . . . . . . . . .  avance rapide
| rewind . . . . . . . . . . . . . . .  rembobiner
| f  . . . . . . . . . bascule le mode plein-écran
| info . . . . .  informations sur le flux courant
| volume [X] . . . . . . modifie/affiche le volume
| volup [X]  . . . . . . . augmente le volume de X
| voldown [X]  . . . . . .  diminue le volume de X
| adev [X] . modifie/affiche le périphérique audio
| achan [X]  . . modifie/affiche les canaux audios
    /* marquee on the fly items */
| marq-marquee CHAINE .  écrit CHAINE sur la vidéo
| marq-x X . . . . . . . décalage depuis la gauche
| marq-y Y . . . . . . . . décalage depuis le haut
| marq-position # . contrôle de position relative
| marq-color # . . . . . . . . . . .  couleur, RGB
| marq_opacity # . . . . . . . . . . . . . opacité
| marq-timeout T . . . disparition du texte, en ms
| marq-size # . . . . . . . . .  taille, en pixels
    /* time on the fly items */
| time-format STRING . . . overlay STRING in video (pas en français)
| time-x X . . . . . . . décalage depuis la gauche
| time-y Y . . . . . . . . décalage depuis le haut
| time-position # . . . . . . .  position relative
| time-color # . . . . . . . . . . .  couleur, RGB
| time-opacity # . . . . . . . . . . . . . opacité
| time-size # . . . . . . . . .  taille, en pixels
    /* logo on the fly items */
| fichier-logo CHAÎNE-DE-CARACTÈRES . . . emplacement du fichier à superposer à la vidéo (overlay)
| logo-x X . . . . . . . . . . . .abscisse
| logo-y Y . . . . . . . . . . . . ordonnée en partant du haut
| logo-position #. . . . . . . . position relative
| logo-transparency # . . . . . . . .transparence

| mosaic-alpha # . . . . . . . . . . . . . . alpha
| mosaic-height #. . . . . . . . . . . . . .hauteur
| mosaic-width # . . . . . . . . . . . . . . largeur
| mosaic-xoffset # . . . .position à partir du coin supérieur gauche
| mosaic-yoffset # . . . .position à partir du coin supérieur gauche
| mosaic-align 0..2,4..6,8..10. . .alignement de la mosaïque
| mosaic-vborder # . . . . . . . . limite verticale
| mosaic-hborder # . . . . . . . limite horizontale
| mosaic-position {0=auto,1=fixe} . . . .position
| mosaic-rows #  . . . . . . .  nombre de rangées
| mosaic-cols #  . . . . . . . nombre de colonnes
| mosaic-keep-aspect-ratio {0,1} . . . .étirement

| help . . . . . . . . . . . . . ce message d’aide
| longhelp . . . . . . . .message d’aide plus long
| logout . . . quitte l’interface sans fermer vlc
| quit . . . . . . . . . . . . . . . .  quitte VLC

 /* Non documentées */
| intf
| get_length : Affiche la durée du média en cours de lecture
| get_time : affiche le position dans la lecture du media
| is_playing : 0 si pas en lecture, 1 sinon
| get_title : affiche le nom du média en cours de lecture

"""
class PilotVlc:
    exe = "/usr/bin/vlc"
    ipFbx="freeplayer.freebox.fr"   # ip destinataire du flux
    port = 8888
    
    def __callVlc(self,cmd):
        print "VLC CALL:",cmd
        self.__t.write(cmd + "\n")
        # le 0.2 ne doit pas etre trop court, sinon les ordres consécutifs
        # ne passe pas (trop rapide)
        # ni trop long, sinon les consécutifs ralentissent l'interface
        b=self.__t.read_until("xx",0.2).strip()
        print "VLC RETURN:",b
        return b
    
    def __init__(self,file):
        cmd=[
            PilotVlc.exe,
                "--intf", "rc",
                #~ #"--extraintf","rc",
                "--rc-host",":%d" % PilotVlc.port,
                """--sout="#std" """,
                "--sout-standard-access=udp",
                "--sout-standard-mux=ts",
                "--sout-standard-url=%s:1234" % PilotVlc.ipFbx,
                "--sout-ts-pid-video=68",
                "--sout-ts-pid-audio=69",
                "--sout-ts-pcr=80",
                "--sout-ts-dts-delay=400",
                "--color",
                "--play-and-stop",
                file
                ]
        print " ".join(cmd)
        PilotVlc.pid = os.spawnvp(os.P_NOWAIT,cmd[0],cmd)
        
        # rends pas la main, tant que la cnx telnet n'est pas ...
        while 1: # boucle active .... (ultra pas bien)
            try:
                t=telnetlib.Telnet("127.0.0.1",PilotVlc.port)
            except:
                t=None
            if t: break;
        self.__t = t # stock la com telnet
        
    def getInfo(self):
        """ renvoi les infos du media actuel """
        return self.__callVlc("info")
        
    def isPlaying(self):
        """ renvoi true/false suivant que ça joue ou pas"""
        ret = self.__callVlc("is_playing")
        try:
            return int(ret)==1
        except:
            return False
        
    def getTitle(self): # bof
        """ renvoi le titre du media actuel """
        return  self.__callVlc("get_title")
        
    def getLength(self):
        """ renvoi la longueur en sec du media actuel """
        ret=self.__callVlc("get_length")
        return int(ret)
        
    def getTime(self):
        """ renvoi le nb de sec passé du media actuel """
        ret=self.__callVlc("get_time")
        return int(ret)
        
    def getVolume(self): # 0 a 1024
        """ renvoi le volume entre 0 et 1024 """
        buf=self.__callVlc("volume")
        expr = re.compile( r'Volume is (\d+)',re.IGNORECASE )
        g = expr.search( buf )
        if g:
            return int(g.group(1))
        else:
            print "no volume ?!"
            
        
    def getPlaylist(self):
        """ retourne un tuple :
                - (list) la playlist des fichiers actuel sous forme de list
                - (int) la position de l'actuel ou None (attention au 0==None!!)
        """
        buf=self.__callVlc("playlist")
        list=[]
        expr = re.compile( r' {3}(.*)$',re.IGNORECASE )
        playing=None
        for i in buf.split("|"):
            i=i.strip()
            if i:
                g = expr.search( i )
                if g:
                    if i[0]=="*" : playing=len(list)
                    list.append( g.group(1) )
        
        return list,playing


    def setVolume(self,v): # 0 à 1024
        """ positionne le volume de vlc """
        self.__callVlc("volume %d"% max(0,min(v,1024)) )


    def add(self,file):
        self.__callVlc("add %s"% file)
        
    def addplay(self,file):
        self.__callVlc("addplay %s"% file)
        

    #~ def play(self):
        #~ self.__t.write("play\n")

    #~ def pause(self):
        #~ self.__t.write("pause\n")
    #~ def stop(self):
        #~ self.__t.write("stop\n")
    #~ def next(self):
        #~ self.__t.write("next\n")
    #~ def prev(self):
        #~ self.__t.write("prev\n")
    #~ def seek(self,sec): # sec/length
        #~ self.__t.write("seek %d\n" % sec)
    #~ def clear(self):
        #~ self.__t.write("clear\n")
        
    def cmd(self,cmd):
        self.__callVlc(cmd)
        
    def quit(self):
        self.__callVlc("quit")

if __name__=="__main__":
    v=PilotVlc("/home/manatlan/fbx/playlist.m3u")
    #~ print v.isPlaying()
    #~ print v.getTitle()
    #~ print v.getLength()
    #~ print v.getTime()
    #~ v.pause()
    #~ v.seek(500)
    #~ v.setVolume(-522)
    #~ v.clear()
    #~ v.add("/media/data/mp3/full albums/I Am Kloot - Gods and Monsters/I Am Kloot - Gods And Monsters - 02 - Gods And Monsters.mp3")
    #~ print "---",v.getVolume()
    #~ buf,p=v.getPlaylist()
