#!/usr/bin/env python
##
##	Copyright (C) 2005 manatlan
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published
## by the Free Software Foundation; version 2 only.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
"""
feedBox - a python server for a freebox

par rapport a freeportail
- conception plugin hyper simple (un dossier contient tout)
- autoreload (pas besoin de sortir du serveur pour du dev)
- httpserver sur mesure (cherrypy free)
- libxml2 free -> minidom
- templating integre ++
- lecture de tout type de fichier fbx (et m3u)
- repertoire media
- full unicode (dans le httpserver et template)
- lancement de vlc en local (sans gui)
- se rappel de la playlist precedente
- dynamik image possible (meme avec params!)
- yield/generator possible pour le renvoi du flux http (avec mime-type)
- seek dans les medias
- play media audio-video ONLY
- meteo ne charge le dep qu'une fois par jour
- fonctionne a l'identik dans un browser et dans la fbox

"""
import sys
import os
from BaseHTTPServer import BaseHTTPRequestHandler,HTTPServer
import BaseHTTPServer
import cgi

import common.autoreload
common.autoreload.run()

import socket,urllib

from common.pilotvlc import PilotVlc

# ==============================================================================
class FBS(BaseHTTPServer.BaseHTTPRequestHandler):
# ==============================================================================
    """
    __data
    """
    pathPlugins="plugins"
    
    def __init__(self, request, client_address, server):  
        self.allow_reuse_address=True
        BaseHTTPServer.BaseHTTPRequestHandler.__init__(self, request, client_address, server)  

    @staticmethod
    def init(path):
        FBS.__data={}
        FBS.__path=path

        for i in os.listdir(FBS.pathPlugins):
            print "Load plugin %s" % i
            folder = FBS.pathPlugins+"/"+i
            jo = __import__(folder,globals(), locals())

            FBS.__data[i]=(
                            jo.__order__,
                            jo.__title__,
                            jo.main(),
                            i+"/index",
                            folder
                        )

        # recupere le plugin home
        # et lui associe sa liste de plugin
        home=None
        ordres={}
        for i in FBS.__data:
            ordre,titre,instance,url,folder = FBS.__data[i]
            if ordre: # evite home
                ordres[ordre] = (titre,url)
            else:
                home = instance
        if not home:
            raise "missing plugin 'home' !"
        lo = ordres.keys()
        lo.sort()
        
        # associe a home, sa liste de plugin ([titre,url],[],...)
        home.liste = [ordres[i] for i in lo]


    class Redirect:
        def __init__(self,url):
                self.code=302
                self.url = url
                
    def serveStatic(self,file):
        print "serve static content",file
        self.send_response(200, 'OK')
        ext = file.split(".")[-1].lower()
        if ext in ["gif"]:
            self.send_header('Content-type', 'image/gif')
        else:
            self.send_header('Content-type', 'text/html')
        self.end_headers()
        self.wfile.write( open(file,"rb").read() )
        
    def do_GET(self):
        # /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\
        #~ print self.path
        if self.path.find('?')>=0:
            page = self.path[1:self.path.index("?")]
            args=self.query(cgi.parse_qs(self.path[self.path.find('?')+1:]))
        else:
            page = self.path[1:]
            args=[]

        for i in args:
            args[i]=args[i].decode("iso-8859-15")

        #~ FBS.__ip=self.client_address[0]
        
        _l = page.strip("/").split("/")
        one = _l[0]
        second = "/".join(_l[1:])
        if second:
            if one in FBS.__data:
                sobj = one
                page = second
            else:
                sobj = "home"
                page = second
        else:
            sobj = "home"
            if not page: page="index"
                
        ordre,titre,instance,url,folder = FBS.__data[sobj]

        if sobj=="home":
            staticFile = os.path.join(FBS.__path,"common","static",page)
        else:
            staticFile = os.path.join(FBS.__path,folder,page)
            
        if os.path.isfile( staticFile ):
            self.serveStatic(staticFile)
        else:
            os.chdir(os.path.join(FBS.__path,folder))
            
            page=page.split(".")[0] # enleve l'eventuel extension
            
            if hasattr(instance,page):
                obj = getattr(instance,page)
                
                #~ try:
                if hasattr(obj,"content_type"):
                    # the page/method has a different content-type, use it
                    content_type=getattr(obj,"content_type")
                else:
                    # default ct
                    content_type="text/html"
                    
                if args:
                    # if there are args, call with args
                    b=obj(*(),**(args))  # generator de Site."page"() 
                else:
                    # if there aren't args, call with no args
                    b=obj()  # generator de Site."page"() 
                    
                if hasattr(b,"next"):
                    # it's a generator()
                    buf = b.next()
                    
                    # le premier est le mime type
                    self.send_response(200, 'OK')
                    self.send_header('Content-type', buf)
                    self.end_headers()
                        
                    while True:
                        # fetch its yield statement
                        try:
                            self.wfile.write( b.next() )
                        except StopIteration:
                            break
                            
                elif b!=None:
                    if b.__class__.__name__=="Redirect":
                        self.send_response(b.code) 
                        self.send_header('Location', b.url) 
                        self.root.end_headers()                             
                    elif type(b)==tuple and len(b)==2:
                        self.send_response(200, 'OK')
                        self.send_header('Content-type', b[0])
                        self.end_headers()
                        self.wfile.write( str(b[1]) )
                    else:
                        self.send_response(200, 'OK')
                        self.send_header('Content-type', content_type)
                        self.end_headers()
                        self.wfile.write( str(b) )
                else:
                    self.send_response(404, 'OK')
                    self.send_header('Content-type', 'text/html')
                    self.end_headers()
                    self.wfile.write("404 not found !"%page)
                        
                #~ except TypeError,detail:
                    #~ b="Type Error : " + str(detail)
                    #~ self.send_response(200, 'OK')
                    #~ self.send_header('Content-type', 'text/html')
                    #~ self.end_headers()
                    #~ self.wfile.write( "path '%s' " % self.path )
                    #~ self.wfile.write( b )
                #~ except Exception,detail:
                    #~ b="Error : " + str(detail)
                    #~ self.send_response(200, 'OK')
                    #~ self.send_header('Content-type', 'text/html')
                    #~ self.end_headers()
                    #~ self.wfile.write( "path '%s' " % self.path )
                    #~ self.wfile.write( b )
                
            else:
                self.send_response(404, 'OK')
                self.send_header('Content-type', 'text/html')
                self.end_headers()
                self.wfile.write("404 , page '%s' not found !"%page)
        


    def query(self,parsedQuery):
        """Returns the QUERY dictionary, similar to the result of cgi.parse_qs
        except that :
        - if the key ends with [], returns the value (a Python list)
        - if not, returns a string, empty if the list is empty, or with the
        first value in the list"""
        res={}
        for item in parsedQuery.keys():
            value=parsedQuery[item] # a Python list
            if item.endswith("[]"):
                res[item[:-2]]=value
            else:
                if len(value)==0:
                    res[item]=''
                else:
                    res[item]=value[0]
        return res

    @staticmethod
    def serve_forever(port):
        HTTPServer(('', port), FBS).serve_forever()
        
        
    
# To test on different platform (for portability) (it works on linux/win ! manatlan)
if __name__ == "__main__":

    path = os.path.split(sys.argv[0])[0]
    if path: os.chdir(path)
    sys.path.append(os.path.join(os.getcwd(), 'common/'))
    
    
    PilotVlc.start("playlist.m3u")
    
    port=8080
    FBS.init(os.getcwd())
    print "Serving at http://%s:%d"%("127.0.0.1",port)
    FBS.serve_forever(port)

    #~ config = {'staticContentList': [('settings.html', 'static/settings.html'), ('pics', 'pics')]}
    #~ cpg.server.start(configMap = config)
