#!/usr/bin/env python
# -*- coding: utf-8 -*-
import random
import urllib
__title__="media"
__order__=1000

TMP="templates/"

import sys, os
from common.medialib import getFiles,getAllFiles,getExtVlcOpt
from common.pilotvlc import PilotVlc
from common.template import Template
#~ def cleanpath(path):
    #~ assert type(path)==unicode
    #~ return path.strip(u'"')

#~ def convertspaces(path):
    #~ assert type(path)==unicode
    #~ return path.replace(u" ",u"%20")

def basename(path, space = False):
    if ":\\" in path:
        path = path.split(":\\")[1]
    if space:
        path = path
    path = path.replace('\\', '/')
    path = path.split('/')
    path = path[len(path)-1]
    return path

def redirect(topage):
    topage = str(topage)
    return Template("redirect.html")
    

class main(object):

    def __init__(self):
        #~ self.setExts(["jpeg","jpg","gif","png","avi","divx","dv","mpeg","mpg","mp3","ogg","wma","mpc","m3u"])
        self.setExts(["avi","divx","dv","mpeg","mpg","mp3","ogg","wma","mpc","m3u"]) # pas d'image !!
        self.setRoot(u"../../medias")
        self.__vlc = PilotVlc() #local vlc
        

    def setRoot(self,root=u"/"):
        assert type(root)==unicode
        self.__root = root

    def setExts(self,exts=[]):
        self.__exts = exts

    #====================================================================
    def browse(self,rep=u""): 
    #====================================================================
        if u".." in rep: rep=u"" # security
       
        rep=urllib.unquote(rep)
        rrep = os.path.abspath( os.path.join(self.__root,rep) )
        assert type(rrep)==unicode
        pdirs,pfiles = getFiles(rrep,self.__exts)
        if rep!=u"":
            parent=os.path.dirname(rep)
        else:
            parent=u""

        dirs=[ ( 
                os.path.basename(i),
                urllib.quote(os.path.join(rep,os.path.basename(i))),
                i 
               ) for i in pdirs]
        files=[(os.path.basename(i),urllib.quote(i)) for i in pfiles]
        
        parent = parent=urllib.quote(parent)
        rrep = urllib.quote(rrep)
        t_title="Media Browser"
        t_back="index"
        return Template()

        #~ dirs=[ ( 
                #~ basename(i),
                #~ os.path.join(convertspaces(rep),basename(i, True)),
                #~ i 
               #~ ) for i in pdirs]
        #~ files=[(basename(i),convertspaces(i)) for i in pfiles]
        #~ return renderTemplate(file = TMP+"browse.html")
    

    #==================================================================

    def play(self,file):
        """ file peut etre :
                - un repertoire
                - un fichier (voire un m3u)
                - une url
            fabrique la playlist special vlc, et lance vlc en lecture
        """
        file=urllib.unquote(file)
        
        liste=[]
        if os.path.isdir(file):
            # build a playlist with all files (recursively)
            for i in getAllFiles(file,self.__exts):
                liste.append(i)
        elif os.path.isfile(file) and file[-4:].lower()==".m3u":
            # build a playlist from this playlist
            for i in open(file,"r"):
                i=i.strip().decode(sys.getfilesystemencoding())
                if i[0]!="#":
                    liste.append(i)
        else:
            # simply add (a file or an url)
            liste.append(file)

        if not liste:
            return redirect('browse')
        else:
            fid=open(u"../../playlist.m3u","w")
            if fid:
                fid.write( "\n".join(liste).encode(sys.getfilesystemencoding()) )
                fid.close()
                
                self.__vlc.empty()
                self.__vlc.add( "playlist.m3u" ) # play de suite
                self.__vlc.play( 0 ) # a pour action de fetcher la playlist
               
            return redirect('cmd?cmd=play')
        



    #~ def message(self,msg):
        #~ return renderTemplate(file = TMP+"message.html")


    def empty(self):
        return Template()


    def cmd(self, cmd, arg = None):
        if cmd == "play" and arg!=None:
            self.__vlc.play(arg)
        else:
            getattr(self.__vlc, cmd)()

        if cmd in ["pause","stop"]:
            return redirect("index")
        elif (cmd == "next" or cmd == "prev") and (not self.__vlc.isPlaying()):
            return redirect("index")
        else:
            return redirect("empty")
            
    def seek(self,seek):
        seek=int(seek)
        max = self.__vlc.getLength()
        val = str( int( (seek*max) / 100 ) )
        self.__vlc.seek( val)
        return redirect("index")



    #====================================================================
    def index(self, rnd = ""):
        if self.__vlc.isPlaying():
            playing=self.__vlc.getTitle().decode(sys.getfilesystemencoding())
            msg=u"Playing %s : %d%s" % (basename(playing),self.__vlc.getPercent(),'%')
            isPlaying=True
        else:
            msg=unicode(self.__vlc["stream_state"].capitalize())
            isPlaying=False
        seek=None
        
        items = self.__vlc.getPlaylist()

        playlist=[]
        for item in items:
            name = basename(item["title"])

            # suivant la position de l'item, on highlight ou pas
            if item["current"] == True: # item en cours, dans la playlist
                name='* %s' % name
            else:
                name='<a href="cmd?cmd=play&arg=%s">%s</a>' % (item["id"], name)
                
            playlist.append(name.decode(sys.getfilesystemencoding()))
        # msg
        # playlist
        playing = self.__vlc.isPlaying()

        t_title="Media Player"
        t_back="/index"
        t_head="""
                <meta name="refresh" content="10;url=index">
                <META HTTP-EQUIV="Refresh" CONTENT="10; URL=index">
                <link rel="play" href="cmd?cmd=play">
                <link rel="pause" href="cmd?cmd=pause">
                <link rel="stop" href="cmd?cmd=stop">
                <flags volume_key="false">
        """

        return Template()
        #~ return 

