#!/usr/bin/python
from common.template import Template
from common.xmldoc import XmlDoc
import feedparser

__title__="rss"
__order__=3000


    
class main:
    def index(self):
        dom = XmlDoc(file="rss.xml")
        array = []
        i = 0
        for node in dom.getAll("feed"):
            i += 1
            name= node.getAttr("name")
            array.append( [str(i), name ] )
        t_title="RSS"
        t_back="/index"
        return Template()

    def __finditemnum(self, num, feed):
        feednum = self.__findfeednum(feed)
        url=feednum.getText()
        rss = feedparser.parse(url)
        i = 0
        num = int(num)
        for item in rss.entries:
            i += 1
            if i == num:
                return item
        
        return False

    def __findfeednum(self, num):
        dom = XmlDoc(file="rss.xml")
        i = 0
        num = int(num)
        for item in dom.getAll("feed"):
            i += 1
            if i == num:
                return item 
        
        return False

    def item(self, num, feed):
        item = self.__finditemnum(num, feed)
        if not item:
            return "No RSS item found for num = %s and feed = %s" % (num, feed)
        
        name = item.title
        description = item.summary
        
        t_title="RSS read"
        t_back="view?num="+str(feed)
        return Template()


    def view(self, num):
        item = self.__findfeednum(num)
        if not item:
            return "No RSS feed found for num = "+str(num)	
            
        url=item.getText()
        rss = feedparser.parse(url)
        array = []
        
        name = rss.feed.title
        
        description = True
        
        i = 0
        for item in rss.entries:
            i += 1
            if not hasattr(item, 'summary'):
                description = False
            
            array.append((str(i), item.title))

        t_title="RSS liste"
        t_back="index"
        return Template()

    
